// cert_dummy.c
//

#include <pktlab.h>

#include "private.h"

//
// EXPORTED FUNCTION DEFINITIONS
//

struct pktlab_certificate * pktlab_create_cert(void) {
    trace("%s()", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return NULL;
}

int pktlab_load_cert_pem (
    const char * pem, uint_fast32_t pemlen,
    struct pktlab_certificate * cert)
{
    trace("%s(pemlen:%u)", __func__, (unsigned) pemlen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_load_cert_der (
    const uint8_t * der, uint_fast32_t derlen,
    struct pktlab_certificate * cert)
{
    trace("%s(derlen:%u)", __func__, (unsigned) derlen);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_get_cert_der (
    const struct pktlab_certificate * cert,
    void ** der, uint_fast32_t * derlen)
{
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_decode_certificate (
    const struct pktlab_certificate * cert,
    const struct pktlab_publickey * signkey,
    struct pktlab_cert_info ** ptr)
{
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return PKTLAB_DECODE_UNKNOWN_FAULT;
}

int pktlab_verify_certificate_signature (
    const struct pktlab_certificate * cert,
    const struct pktlab_publickey * signkey)
{
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_cleanup_cert(struct pktlab_certificate * cert) {
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_get_agent_key (
    const struct pktlab_certificate * agent_cert,
    uint8_t * agent_pubkey)
{
    trace("%s(...)", __func__);
    debug("%s not supported (SSL not enabled)", __func__);
    return -1;
}

int pktlab_parse_endpoint_rep_cert_chain (
    struct pktlab_certificate ** cert_ls,
    uint_fast32_t certnum, const uint8_t * endpoint_key,
    struct pktlab_publickey * root_eop_key,
    uint8_t ** subable_channels, uint_fast32_t * channelnum)
{
    trace("%s(certnum:%u)",
        __func__, (unsigned) certnum);
    debug("%s not supported (SSL not enabled)", __func__);
    return PKTLAB_PARSE_CHAIN_UNKNOWN_FAULT;
}

int pktlab_parse_controller_exp_cert_chain (
    struct pktlab_certificate ** cert_ls,
    uint_fast32_t certnum,
    const uint8_t * controller_key,
    struct pktlab_publickey * trusted_eop_key,
    uint8_t ** ftdigests, uint_fast32_t * ftcnt,
    uint8_t ** mtdigests, uint_fast32_t * mtcnt,
    char *** priority, uint_fast32_t * pcnt,
    uint8_t * subable_channel)
{
    trace("%s(certnum:%u)",
        __func__, (unsigned) certnum);
    debug("%s not supported (SSL not enabled)", __func__);
    return PKTLAB_PARSE_CHAIN_UNKNOWN_FAULT;
}