// hash_table.h
//

#ifndef _HASH_TABLE_H_
#define _HASH_TABLE_H_

#include "linked_list.h"

#include <stdint.h>

//
// EXPORTED FUNCTION DECLARATIONS
//

struct hash_table; // opaque

typedef uint_fast32_t (*hash_t) (const void * ptr, uint_fast32_t len);

// It is the caller's responsibility to choose good tablesz and hash_func for the hash table.
extern struct hash_table * create_table(uint_fast32_t tablesz, hash_t hash_func);
extern int insert_table (
    const void * key, uint_fast32_t keylen,
    void * value, struct hash_table * table);
extern int remove_table (
    const void * key, uint_fast32_t keylen,
    void ** value, struct hash_table * table);
extern int replace_table (
    const void * key, uint_fast32_t keylen,
    void ** oldvalue, void * newvalue,
    struct hash_table * table);
extern int lookup_table (
    const void * key, uint_fast32_t keylen,
    void ** value, struct hash_table * table);
extern void cleanup_table (
    struct hash_table * table, freedata_t free_data_func, void * free_data_aux);
extern uint_fast32_t size_table(const struct hash_table * table);

#endif