// linked_list.h
// The unkeyed version.
//

#ifndef _LINKED_LIST_H_
#define _LINKED_LIST_H_

#include <stdint.h>

//
// EXPORTED FUNCTION DECLARATIONS
//

struct linked_list; // opaque
struct ll_node;

typedef void (*freedata_t) (void * data, void * aux);

// full list operations
extern struct linked_list * create_ll(void);
extern int push_ll(void * data, struct linked_list * ll);
extern struct linked_list * copy_ll(const struct linked_list * ll); // this reuse data pointer
extern void cleanup_ll(struct linked_list * ll, freedata_t free_func, void * aux);
extern uint_fast32_t len_ll(const struct linked_list * ll);

// per-node operations
extern struct ll_node * get_head(const struct linked_list * ll);
extern struct ll_node * get_next(const struct ll_node * node);
extern struct ll_node * get_node(const struct linked_list * ll, uint_fast32_t indx);
extern void * get_data(const struct ll_node * node);
extern int remove_node(struct linked_list * ll, uint_fast32_t indx, void ** data);
extern int replace_data(struct ll_node * node, void ** olddata, void * newdata);

#endif