#ifndef _PKTIF_UTIL_CYC_QUEUE_H
#define _PKTIF_UTIL_CYC_QUEUE_H

#include <stdbool.h>
#include <stdlib.h>

// a cyclic deque with indexed access
/**
 * @brief A cyclic array with indexed push and head-only pop
 *
 */
struct cyc_queue {
    void **arr;
    // head and tail in terms of array index
    size_t head, tail;
    // max # of elements in the array
    size_t size;

    bool is_empty;
    // some locks needed for writing variables
};

struct cyc_queue *cyc_queue_init(size_t arr_size);
void cyc_queue_destroy(struct cyc_queue *cq);

int cyc_queue_push(struct cyc_queue *cq, void *elem);
void *cyc_queue_peek_head(struct cyc_queue *cq);
void *cyc_queue_pop(struct cyc_queue *cq);
size_t cyc_queue_length(struct cyc_queue *cq);

#endif