#include "gmr_chk.h"

typedef int (*gmr_chk_fn_t)(enum pktlab_message_type);

static inline int mread_gmr_chk(enum pktlab_message_type msg_type) {
    return (msg_type == PKTLAB_MDATA_MESSAGE) ||
           (msg_type == PKTLAB_RESULT_MESSAGE);
}

static inline int accept_status(enum pktlab_message_type msg_type) {
    return (msg_type == PKTLAB_RESULT_MESSAGE);
}

int chk_gmr(enum pktlab_message_type req, enum pktlab_message_type resp) {
    static const gmr_chk_fn_t checkers[] = {
        [PKTLAB_MREAD_MESSAGE] = &mread_gmr_chk,
        [PKTLAB_NOPEN_MESSAGE] = &accept_status,
        [PKTLAB_NCLOSE_MESSAGE] = &accept_status,
        [PKTLAB_NSEND_MESSAGE] = &accept_status,
        [PKTLAB_NCAP_MESSAGE] = &accept_status,
    };

    gmr_chk_fn_t checker;
    if (req < sizeof(checkers) / sizeof(checkers[0])) {
        checker = checkers[req];
    } else {
        return 0;
    }

    if (checker == NULL) {
        return 0;
    }
    return checker(resp);
}