#ifndef _PKTIF_UTIL_LOCK_H
#define _PKTIF_UTIL_LOCK_H

#include <pthread.h>

// a serializing guard
struct ser_guard {
    pthread_mutex_t send_mtx;
    pthread_mutex_t recv_mtx;
    pthread_cond_t cv;
    volatile int send_ctr;
    volatile int recv_ctr;
};

struct ser_guard *ser_guard_create();
int ser_guard_destroy(struct ser_guard *g);

int ser_guard_send_lock(struct ser_guard *g, int *ctr);
int ser_guard_send_unlock(struct ser_guard *g);
int ser_guard_recv_lock(struct ser_guard *g, const int ctr);
int ser_guard_recv_unlock(struct ser_guard *g);
int ser_guard_peek(struct ser_guard *g, const int ctr);

#endif