#ifndef _PTKIF_UTIL_UTIL_H
#define _PTKIF_UTIL_UTIL_H
#include <pktif.h>

#define likely(cond) __glibc_likely(cond)
#define unlikely(cond) __glibc_unlikely(cond)
#define MAX(a, b)                                                              \
    ({                                                                         \
        __typeof__(a) _a = (a);                                                \
        __typeof__(b) _b = (b);                                                \
        _a > _b ? _a : _b;                                                     \
    })

#define MIN(a, b)                                                              \
    ({                                                                         \
        __typeof__(a) _a = (a);                                                \
        __typeof__(b) _b = (b);                                                \
        _a < _b ? _a : _b;                                                     \
    })

#define SYNC_LOOP(cond)                                                        \
    int set = PKTIF_SEL_READ;                                                  \
    while ((cond)) {                                                           \
        fd_set readfds;                                                        \
        FD_ZERO(&readfds);                                                     \
        int nfds =                                                             \
            pktif_prepare_select(pktif, set, 0, &readfds, NULL, NULL, NULL);   \
        nfds = select(nfds, &readfds, NULL, NULL, NULL);                       \
        pktif_process_select(pktif, set, &nfds, &readfds, NULL, NULL, NULL);   \
    }
int util_readmsg(struct pktctrl_obj *obj, struct pktlab_message **msg);
int try_send(struct pktctrl_obj *obj, const struct pktlab_message *msg);

#endif