// prog.h
//

#ifndef _PROG_H_
#define _PROG_H_

#include <pktlab.h>
#include <pktctrl.h>

#include <stdint.h>

#include <sys/select.h>

//
// EXPORTED TYPE
//

// for keeping track of program submission state
struct prog_submit_obj; // opaque

//
// EXPORTED FUNCTION DECLARATIONS
//

extern int prog_init(const char * prog_dir_path);
extern int prog_load(void);
extern void prog_cleanup(void);

extern int prog_lookup_program (
    const uint8_t * prog_digest,
    const void ** encoded_prog, uint_fast32_t * encoded_proglen);

// submit_obj should always be freed
// when program module cleaned up
extern int prog_submit_programs_init_hash (
    struct pktctrl_obj * obj,
    const uint8_t * send_mon_digests, uint_fast32_t send_mon_digest_cnt,
    const uint8_t * recv_mon_digests, uint_fast32_t recv_mon_digest_cnt,
    const uint8_t * filter_digests, uint_fast32_t filter_digest_cnt,
    struct prog_submit_obj ** submit_obj);
extern int prog_submit_programs_init_store (
    struct pktctrl_obj * obj, const char * snikey,
    struct pktctrl_keycert_store * store,
    struct prog_submit_obj ** submit_obj);
extern void prog_submit_programs_cleanup (
    struct prog_submit_obj * submit_obj);

extern int prog_submit_programs_prepare_select (
    int * nfds, fd_set * rset, fd_set * wset,
    pktlab_time_t * select_until,
    struct prog_submit_obj * submit_obj);
extern int prog_submit_programs_process_select (
    const fd_set * rset, const fd_set * wset,
    struct prog_submit_obj * submit_obj);

#endif