// worker.h
//

#ifndef _WORKER_H_
#define _WORKER_H_

#include <stdint.h>

#include <pktlab.h>
#include <pktctrl.h>

//
// EXPORTED CONSTANTS
//

enum worker_msg {
    WORKER_EOF           = 0,
    WORKER_TLS_COMPLETED = 1
};

//
// EXPORTED TYPE DEFINITIONS
//

struct worker_arg {
    // ownership claimed by thread
    // note allocated wa is also owned by thread
    int endpoint_fd;
    int manager_fd;
    uint_fast32_t worker_id;

    // still owned by manager
    char ** exp_prog_n_args;
    struct pktlab_privatekey * k;
    struct pktctrl_keycert_store * store;
};

//
// EXPORTED FUNCTION DECLARATIONS
//

extern void * worker_run(void * arg);

extern int send_worker_msg(int sock, uint8_t msg);
extern int recv_worker_msg(int sock, uint8_t * msg);

#endif