// filter.h
//

#ifndef _FILTER_H_
#define _FILTER_H_

#include <stdint.h>

#include "raw.h"

//
// EXPORTED FUNCTION DECLARATION
//

extern int filter_init(void);
extern void filter_cleanup(void);

extern int filter_verify_ebpf_filter (
    const void * filter, uint_fast32_t filterlen);

extern int filter_run_ebpf_filter (
    const void * filter, uint_fast32_t filterlen,
    void * ctx, uint_fast32_t ctxlen,
    void * data, uint_fast32_t datalen,
    uint64_t * acceptlen);
extern int filter_run_ebpf_filters (
    struct raw_prog * filters,
    void * ctx, uint_fast32_t ctxlen,
    void * data, uint_fast32_t datalen,
    uint64_t * acceptlen);

extern void filter_filter_cache_cleanup(void);

#endif