// filter_dummy.c
// Dummy filter impl. for non-supporting OS
//

#include <inttypes.h>
#include <stdint.h>

#include "console.h"
#include "raw.h"

//
// EXPORTED FUNCTION DEFINITIONS
//

int filter_init(void) {
    trace("%s()", __func__);
    debug("%s not supported for this build", __func__);
    return -128;
}

void filter_cleanup(void) {
    trace("%s()", __func__);
    debug("%s not supported for this build", __func__);
    return;
}

int filter_verify_ebpf_filter (
    const void * filter, uint_fast32_t filterlen)
{
    trace("%s(filterlen:%" PRIuFAST32 ")", __func__, filterlen);
    debug("%s not supported for this build", __func__);
    return -128;
}

int filter_run_ebpf_filter (
    const void * filter, uint_fast32_t filterlen,
    void * ctx, uint_fast32_t ctxlen,
    void * data, uint_fast32_t datalen,
    uint64_t * acceptlen)
{
    trace("%s(filterlen:%" PRIuFAST32
        ",ctxlen:%" PRIuFAST32 ",datalen:%" PRIuFAST32 ")",
        __func__, filterlen, ctxlen, datalen);
    debug("%s not supported for this build", __func__);
    return -128;
}

int filter_run_ebpf_filters (
    struct raw_prog * filters,
    void * ctx, uint_fast32_t ctxlen,
    void * data, uint_fast32_t datalen,
    uint64_t * acceptlen)
{
    trace("%s(ctxlen:%" PRIuFAST32
        ",datalen:%" PRIuFAST32 ")",
        __func__, ctxlen, datalen);
    debug("%s not supported for this build", __func__);
    return -128;
}

void filter_filter_cache_cleanup(void) {
    trace("%s()", __func__);
    debug("%s not supported for this build", __func__);
    return;
}