// raw.c
//

#include <string.h>

#include "console.h"
#include "util.h"

#include "raw.h"

//
// EXPORTED FUNCTIONS DEFINITIONS
//

struct raw_socket_obj * create_raw_socket_obj(void) {
    struct raw_socket_obj * obj;

    trace("%s()", __func__);

    obj = safe_malloc(sizeof(*obj));
    memset(obj, 0, sizeof(*obj));

    obj->af = obj->rfd = obj->wfd = -1;
    obj->st = ST_RAWINIT;
    obj->cert_prog_ll = NULL;
    return obj;
}

const char * raw_state_name(enum raw_socket_state state) {
    static const char * const names[] = {
        [ST_RAWPREINIT] = "RAWPREINIT",
        [ST_RAWINIT] = "RAWINIT",
        [ST_RAWIDLE] = "RAWIDLE",
        [ST_RAWERROR] = "RAWERROR",
        [ST_RAWUNKNOWN] = "RAWUNKNOWN"
    };

    const char * name = NULL;

    if (state < sizeof(names) / sizeof(names[0]))
        name = names[state];

    return (name != NULL) ? name : names[ST_RAWUNKNOWN];
}