// raw_dummy.c
// pktlab dummy raw socket impl. for non-supporting OS
//

#include <stdint.h>
#include <string.h>
#include <sys/types.h>

#include <pktlab.h>

#include "console.h"
#include "raw.h"

//
// EXPORTED FUNCTION DEFINITIONS
//

struct raw_socket_obj * create_raw_socket_obj(void) {
    trace("%s()", __func__);
    debug("%s not supported due to OS restriction", __func__);
    return NULL;
}

void raw_v4_hdrinfo_read (
    const struct pktlab_vmem_region * restrict rgn,
    uint_fast32_t off, uint_fast32_t len, void * buf)
{
    uint8_t infoarr[PKTLAB_VMEMADDR_SYSPARAM_IP4HDRMOD_FL];

    trace("%s(off:%u,len:%u)", __func__,
        (unsigned) off, (unsigned) len);
    debug("%s not supported due to OS restriction", __func__);

    // do nothing here
    memset(infoarr, PKTLAB_RAWHDR_NOCHG, sizeof(infoarr));
    memcpy(buf, infoarr + off, len);
}

void raw_v6_hdrinfo_read (
    const struct pktlab_vmem_region * restrict rgn,
    uint_fast32_t off, uint_fast32_t len, void * buf)
{
    uint8_t infoarr[PKTLAB_VMEMADDR_SYSPARAM_IP6HDRMOD_FL];

    trace("%s(off:%u,len:%u)", __func__,
        (unsigned) off, (unsigned) len);
    debug("%s not supported due to OS restriction", __func__);

    // do nothing here
    memset(infoarr, PKTLAB_RAWHDR_NOCHG, sizeof(infoarr));
    memcpy(buf, infoarr + off, len);
}